// Polys.java
// Poly $B%/%i%9(B $B%F%9%H(B $B%"%W%l%C%H(B
// Copyright (C) 1996, 1997 Y.Nagatani
// nagatani@eken.phys.nagoya-u.ac.jp

import java.applet.*;
import java.awt.*;

import Poly;

public class Polys extends Applet {
	
	public Poly	poly[];
	public int	polys;
	public int	drawOrder[];
	public int	time;
	public int	PhaseVelo = 1;	//	degree par 1 time
	
	public double	ColorPhase = 0.0,
			ColorPhaseDiv = Math.PI / 18,
			ColorPhaseRelative = Math.PI / 4;
	boolean		RandomColor = false;
	
	public void init() {
		
		try {PhaseVelo = getIntParameter ("PhaseVelo");}
		catch (NumberFormatException e) {}
		
		Color	bg = getColorParameter("bgcolor");
		if (bg != null)
			this.setBackground (bg);
		
		polys = 2;
		poly = new Poly[polys];
		drawOrder = new int[polys];
		drawOrder[0] = 0;	drawOrder[1] = 1;
		
		poly[0] = new Poly (this, size().width, size().height, 5);
		poly[0].setColor(Color.blue);
		poly[0].setScale (0.5);
		
		poly[1] = new Poly (this, size().width, size().height, 3);
		poly[1].setColor(Color.red);
		poly[1].setScale (0.2);
		
		time = 0;
	}
	public void paint (Graphics g) {
		
		moveParameters ();
		//  $BK\Ev$O(B g.clearRect $B$G9T$-$?$$$1$I!"(B
		// g $B$K$O(B g $B$N(B BackGround $B$,$"$k$+$i!#(B
		g.setColor (getBackground());
		g.fillRect (0, 0, size().width, size().height);
		g.setColor (getForeground());
		//
		for (int n = 0 ; n < polys ; n++)
			poly[drawOrder[n]].paint (g);
	}
	public void moveParameters () {
		
		double	arg = 2.0*Math.PI * time * PhaseVelo/360,
			x0 = 0.5 + 0.4 *Math.cos(arg),
			y0 = 0.5 - 0.2 *Math.sin(arg),
			z  = -Math.sin(arg);
		poly[1].setTranslate (x0, y0);
		poly[1].setScale (0.2 + 0.05*z);
		int	r = (int) (230 + 25*z),
			g = (int) (100 + 50*z),
			b = (int) (150 + 30*z);
		poly[1].setColor (new Color (r, g, b));
		poly[0].setRotate (arg/5);
		
		if (z > 0) {
			drawOrder[0] = 0;	drawOrder[1] = 1;
		} else {
			drawOrder[0] = 1;	drawOrder[1] = 0;
		}
		time ++;
	}
	protected Color getColorParameter (String name) {
		
		String	value = getParameter (name);
		int	nColor;
		try {nColor = Integer.parseInt (value, 16);}
		catch (NumberFormatException e) {
			return	null;
		}
		return	new Color (nColor);
	}
	public int getIntParameter (String Command)
					throws NumberFormatException {
		
		String Contents = getParameter (Command);
		return	Integer.parseInt (Contents);
	}
	public String[][] getParameterInfo () {
		
		String info[][] = {
			{"bgcolor", "rrggbb (hexadecimal color value)",
				"background color"},
			{"PhaseVelo", "integer value",
				"Phase Velocity (default=1)"}
		};
		return	info;
	}
	public String getAppletInfo () {
		
		return	"Polys (test applet for Poly class)\n" +
			"Copyright(C) 1996, 1997 Y.nagatani\n" +
			"nagatani@eken.phys.nagoya-u.ac.jp";
	}
}
